import { MagicLibrary, GradeList, MagicTypes } from "./lib/MagicLibrary"; //you can copy MagicLibrary.js from lib folder to your script folder

//first thing you need to define magic library
var MagicLib = new MagicLibrary();

//then you could add your custom item to become magic casting weapon by defining like that
//for better compatibility your custom item should has chargeable component
let casting_item = MagicLib.addCastingWeapon("minecraft:brush");
casting_item.cast_efficiency = 1.2;
casting_item.soul_efficiency = 0.1;
casting_item.fast_swap = true; // this statment to able to fast swap spell when sneak + right click

//you could make custom spellbook by doing something like that
//i reccomend you to add allow offhand component
let spellbook_item = MagicLib.addSpellBook("minecraft:shield");
spellbook_item.compatible_attributes = [
    "creation",
    "restoration",
    "conjuration",
    "destruction",
    "transmutation",
    "manipulation",
    "nature",
    "fire", 
    "void", 
    "dark",
    "water",
    "thunder",
    "wind",
    "light",
    "ice"
];
spellbook_item.incompatible_attributes = [];
spellbook_item.compatible_types = [
    MagicTypes.Create,
    MagicTypes.Action,
    MagicTypes.Summon,
    MagicTypes.Enchance,
    MagicTypes.Combat,
    MagicTypes.Curse
];
spellbook_item.grade = [ GradeList.Basic, GradeList.Master ];
spellbook_item.addPredefinedSpell("fire_bullet"); //this statement is to attach spell by default
spellbook_item.max_spell = 4;
spellbook_item.name = "Something called spellbook";

//this statement is to add attribute points for upgrade in magic reinforcement table
MagicLib.addAttributePoint("minecraft:brush", 10);
MagicLib.addAttributePoint("minecraft:shield", 3);

let predefine_casting_item = MagicLib.addPredefineAttributes("minecraft:brush");
predefine_casting_item.addAttribute("fire", 4);

let predefine_spellbook_item = MagicLib.addPredefineAttributes("minecraft:brush");
predefine_spellbook_item.addAttribute("fire", 1);

MagicLib.send(); // at last dont forget to add this send statement